// simpleFIR.ck
// John Ellinger Music 208 Winter 2014
Impulse imp => dac;
SndBuf buf;
buf.read( me.sourceDir() + "/noise.wav" );
//buf.read( me.sourceDir() + "/StarsNStripes.wav" );
0 => buf.pos;

// Set the gain to the initial Processing
0.5 => float gane; 
0.5 => float a0;
0.5 => float b1;
0.0 => float nowOutput;
0.0 => float previousOutput;
1.0 => float lowhi;
0.0 => float bypass;

// create our OSC receiver
OscRecv recv;
// listen on port 12346 that was defined in Processing
12346 => recv.port;
// start listening
recv.listen();

// listen for the /lab17/gain event followed by one float
recv.event( "/lab17/gain, f" ) @=> OscEvent oeGain;
recv.event( "/lab17/a0, f" ) @=> OscEvent oeA0;
recv.event( "/lab17/b1, f" ) @=> OscEvent oeB1;
recv.event( "/lab17/lowhi, f" ) @=> OscEvent oeLowHi;
recv.event( "/lab17/bypass, f" ) @=> OscEvent oeBypass;

// The OSC Listening function for sliderGain
function void updateGain() 
{
	while ( true )
	{
		// wait for event to arrive
		oeGain => now;
		// grab the next message from the queue
		// it will be one float - the sliderGain value
		while ( oeGain.nextMsg() != 0 )
		{ 
			oeGain.getFloat() => gane;
			<<< "sliderGain", gane >>>;
		}
	}
}

function void updateSliderA0() 
{
	while ( true )
	{
		// wait for event to arrive
		oeA0 => now;
		// grab the next message from the queue. 
		while ( oeA0.nextMsg() != 0 )
		{ 
			oeA0.getFloat() => a0;
			<<< "a0", a0  >>>;
		}
	}
}

function void updateSliderB1() 
{
	while ( true )
	{
		// wait for event to arrive
		oeB1 => now;
		// grab the next message from the queue. 
		while ( oeB1.nextMsg() != 0 )
		{ 
			oeB1.getFloat() => b1;
			<<< "b1", b1  >>>;
		}
	}
}

function void updateLowPassHiPass() 
{
	while ( true )
	{
		// wait for event to arrive
		oeLowHi => now;
		// grab the next message from the queue. 
		while ( oeLowHi.nextMsg() != 0 )
		{ 
			oeLowHi.getFloat() => lowhi;
			if ( lowhi == 1.0 )
				<<< "low pass", lowhi  >>>;
			else if ( lowhi == -1.0 )
				<<< "high pass", lowhi  >>>;
			else
				<<< "bad pass" >>>;
		}
	}
}

function void updateBypass() 
{
	while ( true )
	{
		// wait for event to arrive
		oeBypass => now;
		// grab the next message from the queue. 
		while ( oeBypass.nextMsg() != 0 )
		{ 
			oeBypass.getFloat() => bypass;
			<<< "bypass", bypass  >>>;
		}
	}
}

// spork the OSC listener
spork ~ updateGain(); 
spork ~ updateSliderA0(); 
spork ~ updateSliderB1(); 
spork ~ updateLowPassHiPass(); 
spork ~ updateBypass();

// connect Impulse to dac
imp => dac;

// our counter
0 => int n;
while (true)
{
	if ( n == 0 )
		gane * a0 * buf.valueAt(0) => nowOutput;
	else // + for lowpass
		gane * (a0 * buf.valueAt(n) ) + lowhi * (b1 * previousOutput ) => nowOutput;
	
	if ( bypass )
		gane * buf.valueAt(n) => nowOutput;

	nowOutput => imp.next => previousOutput;

	1::samp => now;
	n++;
	if ( n == buf.samples() )
		0 => n;
}
